<?xml version="1.0"?>

<st-source>
<!-- Changes in change set PV -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on August 26, 2008 at 12:32:36 am</time-stamp>


<methods>
<class-id>PROVISO.ForeignDomainMethod</class-id> <category>private</category>

<body package="SAM-DomainModel" selector="copy:to:">copy: aURI to: localURI 
	
	| delay copyAttempts |
	delay := 500.
	copyAttempts := 0.
	[(copyAttempts := copyAttempts + 1) &gt; 5 
		ifTrue: 
			[^aURI fileSize isZero 
				ifTrue: 
					[self system 
						logDebugFour: #ACQUIRE_FILE
						text: 'Acquired zero length ' , localURI printString]
				ifFalse: [self error: 'copy attempt limit reached']].
	aURI copyTo: localURI.
	localURI fileSize = aURI fileSize and: [aURI fileSize isZero not]] 
		whileFalse: [(self timeFacade delayForMilliseconds: (delay := delay * 2)) wait]</body>

<body package="SAM-DomainModel" selector="waitFor:">waitFor: aURI 
	
	"Wait up to 5 minutes for an export file to appear"
	| delay deadline |
	deadline := Time totalSeconds + 300.
	delay := 500.
	[aURI exists] 
		whileFalse: 
			[Time totalSeconds &gt; deadline 
				ifTrue: [self error: 'export file not found'].
			(self timeFacade delayForMilliseconds: (delay := delay * 2)) wait]</body>
</methods>


<methods>
<class-id>PROVISO.ForeignDomainMethod</class-id> <category>invocation</category>

<body package="SAM-DomainModel" selector="acquireFile:">acquireFile: aURI 
	
	| localURI |
	self system 
		logDebugFour: #ACQUIRE_FILE
		text: 'Acquiring file ' , aURI asEncryptedString.
	localURI := self exportFilenameLocalDirectory , aURI tail.
	self waitFor: aURI.
	self 
		copy: aURI
		to: localURI.
	self system 
		logDebugFour: #ACQUIRE_FILE
		text: 'Successfully acquired file into ' , localURI printString.
	^localURI</body>
</methods>


<reorganize>
<class-id>PROVISO.ForeignDomainMethod</class-id> <organization>('accessing' #exportType #exportType: #inputParameterNames: #inputParameters #inputParameters: #isCsvExport #isXmlExport #name #name: #outFileTagForReceiver: #outputParameterNames: #outputParameters #outputParameters: #parseParamString:)
('invocation' #acquireFile: #exportFilenameLocalDirectory #generateExportFilename #generateExportFilenameFrom: #getResultsFromCSV:forClass: #getResultsFromFile:forClass: #getResultsFromXML:forClass: #invokeWithInputs:receiver: #invokeWithInputs:receiver:outFilename:resultsDo: #invokeWithInputs:receiver:resultsDo: #parseErrorResponse:receiver: #parseMethodResponse:receiver:resultsDo: #smeeInvokeWithInputs:receiver: #soapMethodIdentifierForReceiver: #writeXMLOn:inputs:receiver:outFilename: #xmlWithInputs:receiver:outFilename:)
('initialize-release' #initialize)
('private' #copy:to: #waitFor:)
</organization>
</reorganize>


</st-source>
